local global = {dieselPowerPrice = 0.75,
				electricPowerPrice = 0.75,
				steamPowerPrice = 0.75,
				}

function speedCost(speed)
    if speed >= 55 and speed <= 68 then
        return 1
    elseif speed > 68 then
        if speed > 68 and speed <= 74 then
            return 1 + (speed - 68) * 0.000690
        elseif speed > 74 and speed <= 75 then
            return 1.0041400 + (speed - 74) * 0.0008295
        elseif speed > 75 and speed <= 90 then
            return 1.0049695 + (speed - 75) * 0.000620
        elseif speed > 90 and speed <= 99 then
            return 1.0142695 + (speed - 90) * 0.000804
        elseif speed > 99 and speed <= 135 then
            return 1.0215055 + (speed - 99) * 0.000924
        elseif speed > 135 and speed <= 180 then
            return 1.0547695 + (speed - 135)* 0.0009907
        elseif speed > 180 and speed <= 195 then
            return 1.0993510 + (speed - 180)* 0.0008337
        elseif speed > 195 and speed <= 200 then
            return 1.1118565 + (speed - 195)* 0.00125
        elseif speed > 200 and speed <= 230 then
            return 1.1181065 + (speed - 200)* 0.000894
        elseif speed > 230 and speed <= 240 then
            return 1.1449265 + (speed - 230)* 0.001035
        elseif speed > 240 and speed <= 300 then
            return 1.1552765 + (speed - 240)* 0.000825
        elseif speed > 300 and speed <= 375 then
            return 1.2047765 + (speed - 300)* 0.0007741
        elseif speed > 375 and speed <= 500 then
            return 1.262834  + (speed - 375)* 0.000679
        elseif speed > 500 and speed <= 750 then
            return 1.347709  + (speed - 500)* 0.00054
        elseif speed > 750 and speed <= 1000 then
            return 1.482709  + (speed - 750)* 0.00045
        elseif speed > 1000 then
            return 1.595709  + (speed - 1000)* 0.0001571
		end
    elseif speed < 55 then
        if speed >= 54 and speed < 55 then
            return 1 + (55 - speed) * 0.002485
        elseif speed >= 46 and speed < 54 then
            return 1.002485 + (54 - speed) * 0.00082
        elseif speed >= 41 and speed < 46 then
            return 1.009045 + (46 - speed) * 0.0016886801
        elseif speed >= 36 and speed < 41 then
            return 1.0174884005 + (41 - speed) * 0.002874
        elseif speed >= 32 and speed < 36 then
            return 1.0318584005 + (36 - speed) * 0.0039
        elseif speed >= 29 and speed < 32 then
            return 1.0474584005 + (32 - speed) * 0.00525
        elseif speed >= 28 and speed < 29 then
            return 1.0645584005 + (29 - speed) * 0.00583
        elseif speed >= 24 and speed < 28 then
            return 1.0703884005 + (28 - speed) * 0.008
        elseif speed >= 21 and speed < 24 then
            return 1.1023884005 + (24 - speed) * 0.0118112335
        elseif speed >= 20 and speed < 21 then
            return 1.137822101 + (21 - speed) * 0.015177899
        elseif speed >= 19 and speed < 20 then
            return 1.153      + (20 - speed) * 0.016
        elseif speed >= 18 and speed < 19 then
            return 1.169     + (19 - speed) * 0.019
        elseif speed >= 16 and speed < 18 then
            return 1.188    + (18 - speed) * 0.022
        elseif speed >= 14 and speed < 16 then
            return 1.232   + (16 - speed) * 0.030
        elseif speed >= 13 and speed < 14 then
            return 1.292  + (14 - speed) * 0.035
        elseif speed >= 12 and speed < 13 then
            return 1.327 + (13 - speed) * 0.045
        elseif speed >= 11 and speed < 12 then
            return 1.372 + (12 - speed) * 0.048
        elseif speed >= 10 and speed < 11 then
            return 1.42 + (11 - speed) * 0.064
        elseif speed >= 9 and speed < 10 then
            return 1.484 + (10 - speed) * 0.075
        elseif speed >= 8 and speed < 9 then
            return 1.559 + (9 - speed) * 0.094
        elseif speed >= 7 and speed < 8 then
            return 1.653 + (8 - speed) * 0.124
        elseif speed >= 6 and speed < 7 then
            return 1.777 + (7 - speed) * 0.162
        elseif speed >= 5 and speed < 6 then
            return 1.939 + (6 - speed) * 0.228
        elseif speed >= 4 and speed < 5 then
            return 2.167 + (5 - speed) * 0.343
        elseif speed >= 3 and speed < 4 then
            return 2.51 + (4 - speed) * 0.565
        elseif speed >= 2 and speed < 3 then
            return 3.075 + (3 - speed) * 1.135
        elseif speed >= 1 and speed < 2 then
            return 4.21 + (2 - speed) * 3.34
        elseif speed > 0 and speed < 1 then
            return 7.55 + (1 - speed) * 65.8
        end
    end
end	


local function modelCallback(fileName, data)
	if data.metadata.railVehicle then
		if data.metadata.railVehicle.engines then
			if #data.metadata.railVehicle.engines > 0 then
				if data.metadata.railVehicle.engines[1].type == "STEAM" then
					data.metadata.cost.price = speedCost(data.metadata.railVehicle.topSpeed) * 2415 * data.metadata.railVehicle.engines[1].power * global.steamPowerPrice
					data.metadata.maintenance.runningCosts = data.metadata.cost.price / 6
				elseif data.metadata.railVehicle.engines[1].type == "DIESEL" then
					data.metadata.cost.price = speedCost(data.metadata.railVehicle.topSpeed) * 2415 * data.metadata.railVehicle.engines[1].power * global.dieselPowerPrice
					data.metadata.maintenance.runningCosts = data.metadata.cost.price / 6
				elseif data.metadata.railVehicle.engines[1].type == "ELECTRIC" then
					data.metadata.cost.price = speedCost(data.metadata.railVehicle.topSpeed) * 2415 * data.metadata.railVehicle.engines[1].power * global.electricPowerPrice
					data.metadata.maintenance.runningCosts = data.metadata.cost.price / 6
				end
			end
		end
	end
	return data
end

function data()
return {
	info = {
		minorVersion = 0,
		severityAdd = "NONE",
		severityRemove = "NONE",
		name = _("locoPriceAdjuster"),
		description = _('Locomotives initial and O&M cost can be adjusted. This Scriptmod is 100% Savegame compatible, it can be loaded and removed at any time'),
	},
	runFn = function (settings)
		addModifier("loadModel", modelCallback)
	end
}
end
